/*
 *  linux/kernel/panic.c
 *
 *  Copyright (C) 1991, 1992  Linus Torvalds
 */

/*
 * This function is used through-out the kernel (including mm and fs)
 * to indicate a major problem.
 */
#include <stdarg.h>

#include <linux/kernel.h>
#include <linux/sched.h>

#include <linux/delay.h>

asmlinkage void sys_sync(void);	/* it's really int */
extern void hard_reset_now(void);

int in_panic = 0;

NORET_TYPE void panic(const char * fmt, ...)
{
	static char buf[1024];
	va_list args;

	cli();

	va_start(args, fmt);
	vsprintf(buf, fmt, args);
	va_end(args);

	if(!in_panic++) {
	printk(KERN_EMERG "Kernel panic: %s\n",buf);
		*((char *)0)=0;
	}

#if 0
	if (current == task[0])
		printk(KERN_EMERG "In swapper task - not syncing\n");
	else
		sys_sync();
#endif
	{
		int i,j;
		for(i=0;i<300;i++) for(j=0;j<1000;j++) udelay(1000);
	}
	hard_reset_now();
}
